# Windows

## Main Window

class qrenderdoc.MainWindow

  The main parent window of the application.

  ShortcutCallback(QWidget focusWidget)

    Not a member function - the signature for any `ShortcutCallback` callbacks.

    Parameters:

      focusWidget (QWidget) – The widget with focus at the time this shortcut was detected. May be `None`.

  BringToFront()

    Attempts to bring the main window to the front to the user’s focus.

    This may not be possible on all OSs, so the function is not guaranteed to succeed.

  RegisterShortcut(shortcut, widget, callback)

    Register a callback for a particular key shortcut.

    This creates a managed shortcut. Qt’s shortcut system doesn’t allow specialisation/duplication, so you can’t use `Ctrl+S` for a shortcut in a window to update some changes if there’s also a global `Ctrl+S` shortcut on the window. In the end, neither shortcut will be called.

    Instead this function allows the main window to manage shortcuts internally, and it will pick the closest shortcut to a given action. The search goes from the widget with the focus currently up the chain of parents, with the first match being used. If no matches are found, then a ‘global’ default will be invoked, if it exists.

    Parameters:

      - shortcut (str) – The text string representing the shortcut, e.g. ‘Ctrl+S’.

      - widget (QWidget) – A handle to the widget to use as the context for this shortcut, or `None` for a global shortcut. Note that if an existing global shortcut exists the new one will not be registered.

      - callback (ShortcutCallback) – The function to callback when the shortcut is hit.

  UnregisterShortcut(shortcut, widget)

    Unregister a callback for a particular key shortcut, made in a previous call to `RegisterShortcut()`.

    See the documentation for `RegisterShortcut()` for what these shortcuts are for.

    Parameters:

      - shortcut (str) – The text string representing the shortcut, e.g. ‘Ctrl+S’. To unregister all shortcuts for a particular widget, you can pass an empty string here. In this case, `UnregisterShortcut.widget` must not be `None`.

      - widget (QWidget) – A handle to the widget used as the context for the shortcut, or `None` if referring to a global shortcut.

  Widget()

    Retrieves the PySide2 QWidget for this `MainWindow` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Event Browser

class qrenderdoc.EventBrowser

  The event browser window.

  EventFilterCallback(context, filter, params, eventId, chunk, action, name)

    Not a member function - the signature for any `EventFilterCallback` callbacks.

    Called for each event in a capture when performing filtering in the Event Browser. The associated `FilterParseCallback` will be called first to parse the parameters, and is available for caching or syntax checking. The same filter name and params string will be passed to this function.

    Parameters:

      - context (CaptureContext) – The current capture context.

      - filter (str) – The name of the filter function.

      - params (str) – The parameters to the filter function.

      - eventId (int) – The event’s `eventId`.

      - chunk (renderdoc.SDChunk) – The structured data chunk for this event.

      - action (renderdoc.ActionDescription) – The action that contains this event. If the event is the action itself then the event ID will be equal.

      - name (str) – The name of the event as shown in the event browser, for string-based filtering.

    Returns:

      Whether or not this event matches the filter

    Return type:

      bool

  FilterParseCallback(context, filter, params)

    Not a member function - the signature for any `FilterParseCallback` callbacks.

    Called once when the filter changes, to allow parsing any any data caching, as well as reporting of errors in the filter usage.

    Parameters:

      - context (CaptureContext) – The current capture context.

      - filter (str) – The name of the filter function.

      - params (str) – The parameters to the filter function.

    Returns:

      An empty string if the parse succeeded, otherwise any error messages to be displayed to the user, such as syntax or other errors.

    Return type:

      str

  AutoCompleteCallback(context, filter, params)

    Not a member function - the signature for any `AutoCompleteCallback` callbacks.

    Called when autocompletion is triggered inside a filter. The params passed are any previous text inside the filter’s parameter list up to where the cursor is. The callback should return a list of identifiers used for auto-completion.

    The list does not have to be pre-filtered for matches to the `params`, that is provided to allow different autocompletion at different stages (e.g. if there are no parameters, you can autocomplete a property, if a property is already present you can autocomplete valid values for it)

    Parameters:

      - context (CaptureContext) – The current capture context.

      - filter (str) – The name of the filter function.

      - params (str) – The previous parameter text to the filter function.

    Returns:

      A list of strings giving identifiers to autocomplete, or an empty list of there are no such identifiers to prompt.

    Return type:

      List[str]

  GetAPIEventForEID(eventId)

    Uses the existing caching in the event browser to return a `APIEvent` for a specified EID.

    If no capture is loaded or the EID doesn’t correspond to a known event, an empty struct will be returned.

    Parameters:

      eventId (int) – The EID to look up.

    Returns:

      The event corresponding to the EID, or an empty struct if no such EID exists.

    Return type:

      renderdoc.APIEvent

  GetActionForEID(eventId)

    Uses the existing caching in the event browser to return a `ActionDescription` for a specified EID. This action may not be the exact EID specified, but it will be the action that the EID is associated with. I.e. if you specify the EID for a state setting event the next action will be returned.

    If no capture is loaded or the EID doesn’t correspond to a known event, `None` will be returned.

    Parameters:

      eventId (int) – The EID to look up.

    Returns:

      The action containing the EID, or `None` if no such EID exists.

    Return type:

      renderdoc.ActionDescription

  GetCurrentFilterText()

    Returns the current filter text, whether temporary or a saved filter.

    Returns:

      The current filter text.

    Return type:

      str

  GetEventName(eventId)

    Returns the formatted name of an event according to the current settings, whether that be a custom name or an auto-generated name with/without parameter names.

    If no capture is loaded or the EID doesn’t correspond to a known event, an empty string will be returned.

    Parameters:

      eventId (int) – The EID to look up.

    Returns:

      The formatted name of the specified event, or `None` if no such EID exists.

    Return type:

      str

  IsAPIEventVisible(eventId)

    Determines if a given EID is visible with the current filters applied to the event browser.

    If no capture is loaded or the EID doesn’t correspond to a known event, `False` will be returned.

    Parameters:

      eventId (int) – The EID to look up.

    Returns:

      Whether or not the event is currently visible (passing the filters).

    Return type:

      bool

  RegisterEventFilterFunction(name, description, filter, parser, completer)

    Registers a new event browser filter function.

    Filter functions are available as $name() so long as they don’t shadow an existing function. The filter callback will be called for each event to filter.

    The parser callback will be called once when a filter is first specified or the parameters change. Note that a filter can be used multiple times in a filter expression! For this reason the parser may be called multiple times and the filter callback takes the parameters string. If any expensive work is done then the parameters can be used as a cache key to cache any data once per filter expression.

    Parameters:

      - name (str) – The name of the filter function.

      - description (str) – The description of the filter function. This should explain the available parameters (if applicable) and what the filter does. It will be used for documenting to users what each filter means.

      - filter (EventFilterCallback) – The callback to call for each candidate event to perform filtering.

      - parser (FilterParseCallback) – The callback to call when the parsing the parameters and checking for any errors. This can be `None` if no pre-parsing is required.

      - completer (AutoCompleteCallback) – The callback to call when trying to provide autocomplete suggestions. This can be `None` if no completion is desired/applicable.

    Returns:

      Whether or not the registration was successful.

    Return type:

      bool

  SetCurrentFilterText(text)

    Sets the current filter text. This will not modify any saved filter but will modify the scratch filter. The filter is applied immediately.

    Parameters:

      text (str) – The filter text.

  SetEmptyRegionsVisible(show)

    Sets whether or not marker regions which have no visible actions.

    Parameters:

      show (bool) – Whether or not empty regions after filtering will be shown.

  SetShowAllParameters(show)

    Sets whether or not all parameters are shown in the events. By default only the most significant parameters are shown.

    Note

    If custom action names are used this will not have an effect for any such actions. See `SetUseCustomActionNames()`.

    Parameters:

      show (bool) – Whether or not parameter names will be shown.

  SetShowParameterNames(show)

    Sets whether or not parameter names are shown in the events. If disabled, only the value is shown and the parameter is implicit.

    Note

    If custom action names are used this will not have an effect for any such actions. See `SetUseCustomActionNames()`.

    Parameters:

      show (bool) – Whether or not parameter names will be shown.

  SetUseCustomActionNames(use)

    Sets whether or not custom action names are used. Certain actions such as indirect actions it is useful to show a custom action name which contains the actual indirect parameters instead of the ‘raw’ parameters.

    Parameters:

      use (bool) – Whether or not custom action names will be used.

  UnregisterEventFilterFunction(name)

    Unregisters an event browser filter function that was previously registered.

    Parameters:

      name (str) – The name of the filter function.

    Returns:

      Whether or not the unregistration was successful.

    Return type:

      bool

  UpdateDurationColumn()

    Updates the duration column if the selected time unit changes.

  Widget()

    Retrieves the PySide2 QWidget for this `EventBrowser` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## API Inspector

class qrenderdoc.APIInspector

  The API inspector window.

  Refresh()

    Refresh the current API view - useful if callstacks are now available.

  RevealParameter(param)

    Expand the API view to reveal a given parameter and select it.

    Parameters:

      param (renderdoc.SDObject) – The parameter to reveal and select.

  Widget()

    Retrieves the PySide2 QWidget for this `APIInspector` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Pipeline State

class qrenderdoc.PipelineStage(value)

  Specifies a pipeline stage for the `PipelineStateViewer`.

  VertexInput

    The fixed function vertex input stage.

  VertexShader

    The vertex shader.

  HullShader

    The vertex shader.

  TessControlShader

    The tessellation control shader.

  DomainShader

    The domain shader.

  TessEvalShader

    The tessellation evaluation shader.

  GeometryShader

    The geometry shader, including stream-out/transform feedback.

  Rasterizer

    The fixed function rasterizer stage.

  ViewportsScissors

    The viewports and scissors. Helper alias for `Rasterizer`.

  PixelShader

    The pixel shader.

  FragmentShader

    The fragment shader.

  ColorDepthOutput

    The fixed function color and depth output stage, including color blending and depth/stencil testing state.

  Blending

    The color blending state. Helper alias for `ColorDepthOutput`.

  DepthTest

    The depth test state. Helper alias for `ColorDepthOutput`.

  StencilTest

    The stencil test state. Helper alias for `ColorDepthOutput`.

  ComputeShader

    The compute shader.

  SampleMask

    The sample mask.

class qrenderdoc.PipelineStateViewer

  The pipeline state viewer window.

  SaveShaderFile(shader)

    Prompt the user to save the binary form of the given shader to disk.

    Parameters:

      shader (renderdoc.ShaderReflection) – The shader reflection data to save.

    Returns:

      `True` if the shader was saved successfully, `False` if an error occurred.

    Return type:

      bool

  SelectPipelineStage(stage)

    Select a given pipeline stage in the viewer.

    Parameters:

      stage (PipelineStage) – The stage to select.

  Widget()

    Retrieves the PySide2 QWidget for this `PipelineStateViewer` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Texture Viewer

class qrenderdoc.FollowType(value)

  Specifies a type of followed resource for the `TextureViewer`.

  OutputColor

    The index specifies which output color target to select. Shader stage and array index are ignored.

  OutputDepth

    The resource followed is the depth/stencil output target. All other parameters are ignored.

  ReadWrite

    The index specifies a resource within the given shader’s `read-write resources`. The array element then specifies the index within that resource’s array, if applicable.

  ReadOnly

    The index specifies a resource within the given shader’s `read-only resources`. The array element then specifies the index within that resource’s array, if applicable.

  OutputDepthResolve

    The resource followed is the depth/stencil resolve output target. All other parameters are ignored.

class qrenderdoc.TextureViewer

  The texture viewer window.

  GetChannelVisibilityBits()

    Return which channels are currently displayed, as a bitmask.

    If red is visible `0x1` will be set in the returned value, if blue is visible `0x2` will be set, etc.

    Returns:

      The current bitmask showing channel visibility.

    Return type:

      int

  GetCurrentResource()

    Return which resource is currently being displayed in the active tab.

    Returns:

      The ID of the resource being displayed.

    Return type:

      renderdoc.ResourceId

  GetHistogramRange()

    Return the current histogram blackpoint to whitepoint range.

    Returns:

      The current histogram range.

    Return type:

      Tuple[float,float]

  GetPickedLocation()

    Returns the currently selected texel location in the current texture.

    If no location is currently selected or there is no current texture, this will return `(-1, -1)`.

    Returns:

      The currently picked pixel location.

    Return type:

      Tuple[int,int]

  GetSelectedSubresource()

    Return which subresource is currently selected for viewing.

    Returns:

      The subresource currently selected.

    Return type:

      renderdoc.Subresource

  GetTextureOverlay()

    Return the currently selected texture overlay.

    Returns:

      The currently selected texture overlay.

    Return type:

      renderdoc.DebugOverlay

  GetZoomLevel()

    Return the current zoom level, whether manually set or auto-calculated.

    Returns:

      The current zoom level, with 100% being represented as 1.0.

    Return type:

      float

  GotoLocation(x, y)

    Highlights the given pixel location in the current texture.

    Parameters:

      - x (int) – The X co-ordinate.

      - y (int) – The Y co-ordinate.

  IsZoomAutoFit()

    Return whether or not the texture viewer is currently auto-fitting the zoom level.

    Returns:

      `True` if the zoom level is currently auto-fitting.

    Return type:

      bool

  SetChannelVisibility(red, green, blue, alpha)

    Set the visibility of each channel.

    Parameters:

      - red (bool) – Whether the red channel should be visible.

      - green (bool) – Whether the green channel should be visible.

      - blue (bool) – Whether the blue channel should be visible.

      - alpha (bool) – Whether the alpha channel should be visible.

  SetHistogramRange(blackpoint, whitepoint)

    Set the current histogram blackpoint to whitepoint range.

    Parameters:

      - blackpoint (float) – The value that should be mapped to black, component-wise.

      - whitepoint (float) – The value that should be mapped to white, component-wise.

  SetSelectedSubresource(sub)

    Select a particular subresource within the currently selected texture. Any out of bounds parameters will be clamped to the available subresources.

    Parameters:

      sub (renderdoc.Subresource) – The subresource to select.

  SetTextureOverlay(overlay)

    Changes the currently selected overlay the given pixel location in the current texture.

    Parameters:

      overlay (renderdoc.DebugOverlay) – The overlay to enable.

  SetZoomLevel(autofit, zoom)

    Set the zoom level for displaying textures.

    Parameters:

      - autofit (bool) – `True` if the zoom level should be auto-calculated continuously to automatically fit the texture completely in view.

      - zoom (float) – The zoom level as a percentage, with 100% being 1.0. Ignored if `autofit` is `True`.

  ViewFollowedResource(followType, stage, index, arrayElement)

    Select the ‘following’ view and choose which resource slot to follow.

    Parameters:

      - followType (FollowType) – The type of followed resource.

      - stage (renderdoc.ShaderStage) – The shader stage of the shader reflection data to look up.

      - index (int) – The index within the given resource list (if applicable) to follow.

      - arrayElement (int) – The index within the given resource array (if applicable) to follow.

  ViewTexture(resourceId, typeCast, focus)

    Open a texture view, optionally raising this window to the foreground.

    Parameters:

      - resourceId (renderdoc.ResourceId) – The ID of the texture to view.

      - typeCast (renderdoc.CompType) – If possible interpret the texture with this type instead of its normal type. If set to `Typeless` then no cast is applied, otherwise where allowed the texture data will be reinterpreted - e.g. from unsigned integers to floats, or to unsigned normalised values.

      - focus (bool) – `True` if the `TextureViewer` should be raised.

  Widget()

    Retrieves the PySide2 QWidget for this `TextureViewer` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Buffer Viewer

class qrenderdoc.BufferViewer

  The buffer viewer window, either a raw buffer or the geometry pipeline.

  ScrollToColumn(column, stage)
  ScrollToColumn(column) → None

    Scroll to the given column in the given stage’s data.

    Parameters:

      - column (int) – the column to scroll to.

      - stage (renderdoc.MeshDataStage) – The stage of the geometry pipeline to scroll within.

  ScrollToRow(row, stage)
  ScrollToRow(row) → None

    Scroll to the given row in the given stage’s data.

    Parameters:

      - row (int) – the row to scroll to.

      - stage (renderdoc.MeshDataStage) – The stage of the geometry pipeline to scroll within.

  SetCurrentInstance(instance)

    For a mesh view, set the current instance. This is ignored when called on a raw buffer view.

    Parameters:

      instance (int) – The instance to select, will be clamped to the range [0, numInstances-1]

  SetCurrentView(view)

    For a mesh view, set the current multiview view. This is ignored when called on a raw buffer view.

    Parameters:

      view (int) – The view to select, will be clamped to the range [0, numViews-1]

  SetPreviewStage(stage)

    For a mesh view, set the current preview stage. This is ignored when called on a raw buffer view.

    Parameters:

      stage (renderdoc.MeshDataStage) – The stage to show

  ShowMeshData(stage)

    Ensure the given stage’s data is visible and raised, if it wasn’t before.

    Parameters:

      stage (renderdoc.MeshDataStage) – The stage of the geometry pipeline to show data for.

  Widget()

    Retrieves the PySide2 QWidget for this `BufferViewer` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Resource Inspector

class qrenderdoc.ResourceInspector

  The Resource inspector window.

  CurrentResource()

    Return which resource is currently being inspected.

    Returns:

      The ID of the resource being inspected.

    Return type:

      renderdoc.ResourceId

  Inspect(id)

    Change the current resource being inspected.

    Parameters:

      id (renderdoc.ResourceId) – The ID of the resource to inspect.

  RevealParameter(param)

    Expand the resource initialisation chunks to reveal and select a given parameter.

    Parameters:

      param (renderdoc.SDObject) – The parameter to reveal and select.

  Widget()

    Retrieves the PySide2 QWidget for this `ResourceInspector` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Capture Dialog

class qrenderdoc.CaptureDialog

  The executable capture window.

  IsInjectMode()

    Determines if the window is in inject or launch mode.

    Returns:

      `True` if the window is set up for injecting.

    Return type:

      bool

  LoadSettings(filename)

    Loads settings from a file and applies them. See `SetSettings()`.

    Parameters:

      filename (str) – The filename to load the settings from.

  SaveSettings(filename)

    Saves the current settings to a file. See `Settings()`.

    Parameters:

      filename (str) – The filename to save the settings to.

  SetCommandLine(cmd)

    Sets the command line string to use when launching an executable.

    Parameters:

      cmd (str) – The command line to use.

  SetEnvironmentModifications(modifications)

    Sets the list of environment modifications to apply when launching.

    Parameters:

      modifications (List[renderdoc.EnvironmentModification]) – The list of modifications to apply.

  SetExecutableFilename(filename)

    Sets the executable filename to capture.

    Parameters:

      filename (str) – The filename to execute.

  SetInjectMode(inject)

    Switches the window to or from inject mode.

    Parameters:

      inject (bool) – `True` if the window should configure for injecting into processes.

  SetSettings(settings)

    Configures the window based on a bulk structure of settings.

    Parameters:

      settings (CaptureSettings) – The settings to apply.

  SetWorkingDirectory(dir)

    Sets the working directory for capture.

    Parameters:

      dir (str) – The directory to use.

  Settings()

    Retrieves the current state of the window as a structure of settings.

    Returns:

      The settings describing the current window state.

    Return type:

      CaptureSettings

  TriggerCapture()

    Launches a capture of the current executable.

  UpdateGlobalHook()

    Update the current state of the global hook, e.g. if it has been enabled.

  UpdateRemoteHost()

    Update the current state based on the current remote host, when that changes.

  Widget()

    Retrieves the PySide2 QWidget for this `CaptureDialog` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Debug Messages

class qrenderdoc.DebugMessageView

  The debug warnings and errors window.

  Widget()

    Retrieves the PySide2 QWidget for this `DebugMessageView` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Diagnostic Log

class qrenderdoc.DiagnosticLogView

  The diagnostic log viewing window.

  Widget()

    Retrieves the PySide2 QWidget for this `DiagnosticLogView` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Comment View

class qrenderdoc.CommentView

  The capture comments window.

  GetComments()

    Gets the current comments text.

    Returns:

      The current comments text.

    Return type:

      str

  SetComments(text)

    Sets the current comments text.

    Parameters:

      text (str) – The new comments text.

  Widget()

    Retrieves the PySide2 QWidget for this `CommentView` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Statistics Viewer

class qrenderdoc.StatisticsViewer

  The statistics window.

  Widget()

    Retrieves the PySide2 QWidget for this `StatisticsViewer` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Timeline Bar

class qrenderdoc.TimelineBar

  The timeline bar.

  HighlightHistory(id, history)

    Highlights the modifications in a frame of a given resource.

    Parameters:

      - id (renderdoc.ResourceId) – The ID of the resource that is being modified.

      - history (List[renderdoc.PixelModification]) – A list of pixel events to display.

  HighlightResourceUsage(id)

    Highlights the frame usage of the specified resource.

    Parameters:

      id (renderdoc.ResourceId) – The ID of the resource to highlight.

  Widget()

    Retrieves the PySide2 QWidget for this `TimelineBar` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Performance Counter Viewer

class qrenderdoc.PerformanceCounterViewer

  The performance counter view window.

  UpdateDurationColumn()

    Updates duration columns if the selected time unit changes.

  Widget()

    Retrieves the PySide2 QWidget for this `PerformanceCounterViewer` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Python Shell

class qrenderdoc.PythonShell

  The interactive python shell.

  GetScriptText()

    Returns the current script text.

    Returns:

      The current script text.

    Return type:

      str

  LoadScriptFromFilename(filename)

    Sets the current script in the python shell to the contents of the given file.

    Parameters:

      filename (str) – The filename of the script to load.

    Returns:

      Whether or not the script was successfully loaded.

    Return type:

      bool

  RunScript()

    Runs the current script in the python shell.

  SetScriptText(script)

    Sets the current script in the python shell to the given string.

    Parameters:

      script (str) – The text of the script to set.

  Widget()

    Retrieves the PySide2 QWidget for this `PythonShell` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Shader Viewer

class qrenderdoc.ShaderViewer

  A shader window used for viewing, editing, or debugging.

  SaveCallback(context, viewer, encoding, flags, entry, compiled)

    Not a member function - the signature for any `SaveCallback` callbacks.

    Called whenever a shader viewer that was open for editing triggers a save/update.

    Parameters:

      - context (CaptureContext) – The current capture context.

      - viewer (ShaderViewer) – The open shader viewer.

      - id (renderdoc.ResourceId) – The id of the shader being replaced.

      - stage (renderdoc.ShaderStage) – The shader stage of the shader being replaced.

      - encoding (renderdoc.ShaderEncoding) – The encoding of the files being passed.

      - flags (renderdoc.ShaderCompileFlags) – The flags to use during compilation.

      - entryFunc (str) – The name of the entry point.

      - source (bytes) – The byte buffer containing the source - may just be text depending on the encoding.

  RevertCallback(context)

    Not a member function - the signature for any `RevertCallback` callbacks.

    Called whenever a shader viewer that was open for editing is closed.

    Parameters:

      - context (CaptureContext) – The current capture context.

      - viewer (ShaderViewer) – The open shader viewer.

      - id (renderdoc.ResourceId) – The id of the shader being replaced.

  AddWatch(expression)

    Add an expression to the watch panel.

    Parameters:

      expression (str) – The name of the expression to watch.

  CurrentStep()

    Retrieves the current step in the debugging.

    Returns:

      The current step.

    Return type:

      int

  GetCurrentFileContents()

    Return the current text of source files within the viewer. Primarily useful for returning any edits applied when editing a shader.

    Returns:

      The current file contents as a list of (filename, contents) pairs.

    Return type:

      List[Tuple[str,str]]

  RunForward()

    Runs execution forward to the next breakpoint, or the end of the trace.

  SetCurrentStep(step)

    Sets the current step in the debugging.

    Parameters:

      step (int) – The current step to jump to.

  ShowErrors(errors)

    Show a list of shader compilation errors or warnings.

    Parameters:

      errors (str) – The string of errors or warnings to display.

  ToggleBreakpointOnDisassemblyLine(disassemblyLine)

    Toggles a breakpoint at a given disassembly line (starting from 1).

    Parameters:

      disassemblyLine (int) – The line of the disassembly to toggle a breakpoint on.

  ToggleBreakpointOnInstruction(instruction=-1)
  ToggleBreakpointOnInstruction() → None

    Toggles a breakpoint at a given instruction.

    Parameters:

      instruction (int) – The instruction to toggle breakpoint at. If this is `-1` the nearest instruction after the current caret position is used.

  Widget()

    Retrieves the PySide2 QWidget for this `ShaderViewer` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Pixel History

class qrenderdoc.PixelHistoryView

  A pixel history window.

  SetHistory(history)

    Set the history displayed in this window.

    Parameters:

      history (List[renderdoc.PixelModification]) – A list of pixel events to display.

  Widget()

    Retrieves the PySide2 QWidget for this `PixelHistoryView` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget

## Shader Message Viewer

class qrenderdoc.ShaderMessageViewer

  A shader message list window.

  GetEvent()

    Return the EID that this viewer is displaying messages from.

    Returns:

      The EID.

    Return type:

      int

  GetShaderMessages()

    Return the shader messages displayed in this viewer.

    Returns:

      The shader messages.

    Return type:

      List[renderdoc.ShaderMessage]

  IsOutOfDate()

    Returns whether or not this viewer is out of date - if the shaders have been edited since the messages were fetched.

    Returns:

      `True` if the viewer is out of date.

    Return type:

      bool

  Widget()

    Retrieves the PySide2 QWidget for this `ShaderMessageViewer` if PySide2 is available, or otherwise returns a unique opaque pointer that can be passed back to any RenderDoc functions expecting a QWidget.

    Returns:

      Return the widget handle, either a PySide2 handle or an opaque handle.

    Return type:

      QWidget